#include<bits/stdc++.h>
using namespace std;

using num = short;

const num maxN = 1e4;
num n, m;

vector<bitset<maxN> > g;
vector<vector<num> > ans;
bitset<maxN> visited;

void read()
{
    vector<vector<num> > missing;
    cin >>n >>m;
    missing.resize(n);
    g.resize(n);
    for(int i = 0; i < n; i++)
    {
        g[i] = 0;
    }
    ans.resize(n);

    num a, b;
    for(int i = 0; i < m; i++)
    {
        cin >>a >>b;
        missing[a].emplace_back(b);
        missing[b].emplace_back(a);
    }

    for(int i = 0; i < n; i++)
    {
        visited = 0;
        for(num m : missing[i])
        {
            visited[m] = 1;
        }
        for(int j = 0; j < n; j++)
        {
            if(!visited[j])
            {
                g[i][j] = 1;
            }
        }
    }
    /*
    for(int i = 0; i < n; i++)
    {
        cout <<i <<" -> ";
        for(int j : g[i])
        {
            cout <<j <<" ";
        }cout <<endl;
    }
    //*/
}

num bfs(num s, num e)
{
    visited = 0;
    queue<num> q;
    visited[s] = 1;
    ans[s][s] = 0;
    q.push(s);
    while(!q.empty())
    {
        num v = q.front();
        q.pop();
        for(num next = 0; next < n; next++)
        {
            if(g[v][next])
            {
                //cout <<"hh " <<next <<" len ";
                if(!visited[next])
                {
                    visited[next] = 1;
                    ans[s][next] = ans[s][v] + 1;
                    q.push(next);
                }
                if(next == e) return ans[s][e];
            }

        }
    }

    return -4;
}

num dsu[maxN];

void bfsStart(num s)
{
    queue<num> q;
    visited[s] = 1;
    q.push(s);
    while(!q.empty())
    {
        num v = q.front();
        dsu[v] = s;
        q.pop();
        for(num next = 0; next < n; next++)
        {
            if(g[v][next] && !visited[next])
            {
                visited[next] = 1;
                q.push(next);
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();

    visited = 0;
    for(int i = 0; i < n; i++)
    {
        if(!visited[i]) bfsStart(i);
    }
    //for(int i = 0; i < n; i++) cout <<dsu[i] <<" "; cout <<endl;

    int q;
    cin >>q;
    num a, b;
    while(q--)
    {
        cin >>a >>b;
        if(a == b)
        {
            cout <<0 <<endl;
        }
        else if(dsu[a] != dsu[b])
        {
            cout <<-1 <<endl;
        }
        else
        {
            if(ans[a].size() < n) ans[a].assign(n, -2);
            cout <<(ans[a][b] == -2 ? bfs(a, b) : ans[a][b]) <<endl;
        }
    }
}

/*
6 11
0 1
0 2
0 3
1 2
1 4
1 5
2 4
2 5
3 4
3 5
4 5
12
0 5
1 2
1 3
3 2
5 4
3 0
4 1
5 2
0 3
4 0
1 5
2 0

1
2
1
1
2
-1
-1
-1
-1
1
-1
-1
*/
