#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <limits.h>
#include <set>
#include <map>
#include <queue>

using namespace std;

int n,m;
vector<int> gr[10010];
bool closed[10010][10010];
bool used[10010];

int solve(int start,int finish)
{
	pair<int,int> curr;
	queue<pair<int,int> > bfs;
	bfs.push({start,0});
	used[curr.first]=true;
	while(!bfs.empty())
	{
		curr=bfs.front();
		if(curr.first==finish)return curr.second;
		bfs.pop();
		for(int i=0;i<gr[curr.first].size();i++)
		{
			if(!used[gr[curr.first][i]])
			{
				bfs.push({gr[curr.first][i],curr.second+1});
				used[gr[curr.first][i]]=true;
			}
		}
	}
	return -1;
}

void init()
{
	cin>>n>>m;
	int a,b;
	for(int i=0;i<m;i++)
	{
		scanf("%d%d",&a,&b);
		closed[a][b]=true;
		closed[b][a]=true;
		
	}
	for(int i=0;i<n;i++)
	{
		for(int j=i+1;j<n;j++)
		{
			if(!closed[i][j])
			{
				gr[i].push_back(j);
				gr[j].push_back(i);
			}
		}
	}
//	for(int i=0;i<n;i++)
//	{
//		for(int j=0;j<gr[i].size();j++)
//			cout<<gr[i][j]<<" ";
//		cout<<endl;
//	}
	int q;
	cin>>q;
	for(int i=0;i<q;i++)
	{
		scanf("%d%d",&a,&b);
		fill(used,used+10005,false);
		cout<<solve(a,b)<<endl;
	}
}

int main()
{
	init();
}
/*
6 10
0 2
5 0
4 1
1 3
1 5
2 5
2 4
4 0
5 3
4 5
4
1 4
3 2
4 4
0 5
*/