#include <bits/stdc++.h>
using namespace std;

const int MAXN = 50;

bitset<MAXN> infec[MAXN][MAXN];

int maxx, maxy, maxz;

void update(int x, int y, int z);
void update_nbs(int x, int y, int z);

bool is_out_of_bounds(int x, int y, int z) {
	return x < 0 || x >= MAXN || y < 0 || y >= MAXN || z < 0 || z >= MAXN;
}

bool is_infec(int x, int y, int z) {
	if(is_out_of_bounds(x, y, z))
		return false;
	return infec[x][y][z];
}

int count_infec_nbs(int x, int y, int z) {
	int num_infec_nbs = 0;
	if(is_infec(x + 1, y, z))
		++num_infec_nbs;
	if(is_infec(x - 1, y, z))
		++num_infec_nbs;
	if(is_infec(x, y + 1, z))
		++num_infec_nbs;
	if(is_infec(x, y - 1, z))
		++num_infec_nbs;
	if(is_infec(x, y, z + 1))
		++num_infec_nbs;
	if(is_infec(x, y, z - 1))
		++num_infec_nbs;
	return num_infec_nbs;
}

void update(int x, int y, int z) {
	if(is_out_of_bounds(x, y, z) || infec[x][y][z])
		return;

	if(count_infec_nbs(x, y, z) >= 3) {
		infec[x][y][z] = true;
		update_nbs(x, y, z);
	}
}

void update_nbs(int x, int y, int z) {
	update(x + 1, y, z);
	update(x - 1, y, z);
	update(x, y + 1, z);
	update(x, y - 1, z);
	update(x, y, z + 1);
	update(x, y, z - 1);
}

int solve() {
	int ans = 0;
	for(int x = 0; x <= maxx; ++x)
		for(int y = 0; y <= maxy; ++y)
			for(int z = 0; z <= maxz; ++z)
				if(is_infec(x, y, z))
					ans += 6 - count_infec_nbs(x, y, z);
	return ans;
}

int main() {
	int n;
	cin >> n;
	for(int i = 0; i < n; ++i) {
		int x, y, z;
		cin >> x >> y >> z;
		maxx = max(maxx, x);
		maxy = max(maxy, y);
		maxz = max(maxz, z);
		infec[x][y][z] = true;
		update_nbs(x, y, z);
	}
	cout << solve() << endl;
	return 0;
}
