#include<bits/stdc++.h>
using namespace std;

const int nmax=1e4+42,MX=1e6+42;
int n,m;

bitset<nmax> adj[nmax];

vector< pair<int,int> > mem[nmax];

int outp[MX];

vector<int> active,help;
int dist[nmax];

queue< pair<int,int> > q;

int parent[nmax];
int root(int node)
{
    if(parent[node]==node)return node;
    parent[node]=root(parent[node]);
    return parent[node];
}

void init_parent()
{
    double T=clock();

    for(int i=1;i<=n;i++)parent[i]=i;

    for(int i=1;i<=n;i++)
        for(int j=i+1;j<=n;j++)
            if(adj[i][j]==0)parent[root(i)]=root(j);

    for(int i=1;i<=n;i++)parent[i]=root(i);
}

void solve(int source)
{
    memset(dist,-1,sizeof(dist));

    active={};

    for(int i=1;i<=n;i++)
        if(i!=source&&parent[source]==parent[i])
        {
            if(adj[source][i]==0)
            {
                dist[i]=1;
                q.push({i,1});
                continue;
            }

            active.push_back(i);
        }
    //cout<<source<<" -> "<<active.size()<<endl;

    //cout<<"solve "<<source<<endl;

    while(q.size())
    {
        pair<int,int> tp=q.front();

        q.pop();

        dist[tp.first]=tp.second;

        //cout<<"dist "<<tp.first<<" -> "<<tp.second<<endl;

        help={};

        for(auto w:active)
        {
            //if(pos<adj[tp.first].size())cout<<"blocked "<<adj[tp.first][pos]<<" tried "<<w<<endl;

            if(adj[tp.first][w])
            {
                help.push_back(w);

                continue;
            }

            q.push({w,tp.second+1});
        }

        active=help;
    }

    //cout<<"---"<<endl;

    for(auto w:mem[source])
        outp[w.second]=dist[w.first];
}

mt19937 rng(42);

int que;
/*
void gen()
{
    n=10000;
    for(int i=1;i<=sqrt(n);i++)
        for(int j=i+1;j<=n;j++)
            adj[i][j]=1,adj[j][i]=1;

    int q=n*sqrt(n);

    que=q;

    while(q)
    {
        int u=rng()%n+1;
        int v=rng()%n+1;

        mem[u].push_back({v,q});

        q--;
    }
}
*/

int deg[nmax];

int main()
{
    //gen();

    scanf("%i%i",&n,&m);

    for(int i=1;i<=n;i++)deg[i]=n-1;

    for(int i=1;i<=m;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);
        u++;
        v++;

        deg[u]--;
        deg[v]--;

        adj[u][v]=1;
        adj[v][u]=1;
    }

    init_parent();

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);
        u++;
        v++;

        if(deg[u]>deg[v])swap(u,v);

        //deg[u]<=deg[v]

        //cout<<u<<" "<<v<<" -> "<<parent[u]<<" "<<parent[v]<<endl;

        if(parent[u]!=parent[v])
        {
            outp[i]=-1;
            continue;
        }

        if(adj[u][v]==0)
        {
            outp[i]=(u!=v);
            continue;
        }

        if(deg[u]+deg[v]>n)
        {
            outp[i]=2;
            continue;
        }

        mem[u].push_back({v,i});
    }

    //double T=clock();

    for(int i=1;i<=n;i++)
        if(mem[i].size())
            solve(i);

    //cout<<"T= "<<1.0*(clock()-T)/CLOCKS_PER_SEC<<endl;

    for(int i=1;i<=q;i++)
        printf("%i\n",outp[i]);

    return 0;
}