#include "playlists.h"
#include<bits/stdc++.h>
using namespace std;
/*
static int n, k, s;
static double p;
static std::mt19937 mt(42);

static const int GUESS_ROUNDS = 20000;

static void setResult(std::string message)
{
    std::cout << message << std::endl;
    exit(0);
}

static void input()
{
    std::cin >> n >> k >> s >> p;
}

static std::vector<std::vector<int>> playlists;

static void verifyPlaylists()
{
    if (playlists.size() != n)
        setResult("Wrong number of playlists: " + std::to_string(playlists.size()));

    for (std::vector<int> playlist : playlists)
    {
        if (playlist.size() != k)
            setResult("Wrong number of songs: " + std::to_string(playlist.size()));

        for (int song : playlist)
        {
            if (song < 0 || song >= s)
                setResult("Invalid song: " + std::to_string(song));
        }
    }
}

static int currentPlaylist;
static int currentSong;
static int songsPlayed = 0;
static int correctSongsPlayed = 0;

static void startNewPlaylist()
{
    currentPlaylist = mt() % n;
    currentSong = 0;
    shuffle(playlists[currentPlaylist].begin(), playlists[currentPlaylist].end(), mt);
    songsPlayed = 0;
}

int nextSong()
{
    songsPlayed++;

    if (currentSong >= k)
        setResult("Trying to play songs after playlist is over");

    int song = playlists[currentPlaylist][currentSong];
    currentSong++;

    return song;
}
*/
const int nmax=100+42;

vector< vector<int> > ret={};
int cnt[nmax][nmax];

int test;
double prob_wanted;

std::vector<std::vector<int>> makePlaylists(int n, int k, int s, double p)
{
    mt19937 rng(42);

    prob_wanted=p+0.01;

        for(int i=0;i<min(n,s);i++)
        {
            vector<int> cur={};

            for(int j=0;j<k;j++)
                cur.push_back(i);

            sort(cur.begin(),cur.end());

            for(auto w:cur)
                cnt[ret.size()][w]++;

            ret.push_back(cur);
        }

    for(int i=min(n,s);i<n;i++)
    {
        vector<int> cur={};

        for(int j=0;j<k;j++)
            cur.push_back(rng()%s);

        sort(cur.begin(),cur.end());

        for(auto w:cur)
            cnt[ret.size()][w]++;

        ret.push_back(cur);
    }

    /*
    cout<<"ret: "<<endl;
    for(int i=0;i<n;i++)
    {
        cout<<i<<" -> ";for(auto w:ret[i])cout<<w<<" ";cout<<endl;
    }
    */

    return ret;
}

int cnt_on[nmax];
vector<int> seen={};

double correct=0;

int guessPlaylist()
{
    memset(cnt_on,0,sizeof(cnt_on));
    seen={};

    mt19937 rng(42);

    vector<int> possible={};
    for(int j=0;j<ret.size();j++)
        possible.push_back(j);

    int ask=ret[0].size();

    test++;

    while((correct+1.0/possible.size())<prob_wanted*test&&ask)
    {
        ask--;

        int me=nextSong();

        seen.push_back(me);
        cnt_on[me]++;

        vector<int> possible_new={};

        for(auto w:possible)
        {
            bool ok=1;

            for(auto p:seen)
                if(cnt_on[p]>cnt[w][p])ok=0;

            if(ok)possible_new.push_back(w);
        }

        possible=possible_new;
    }

    correct+=1.0/possible.size();

    int me=rng();
    me=abs(me);

    return possible[me%possible.size()];
}
/*
int main()
{
    std::ios::sync_with_stdio(false);

    input();
    playlists = makePlaylists(n, k, s, p);
    verifyPlaylists();

    int correctGuesses = 0;
    for (int i = 0; i < GUESS_ROUNDS; i++)
    {
        startNewPlaylist();
        int guess = guessPlaylist();

        if (guess < 0 || guess >= n)
            setResult("Invalid guess: " + std::to_string(guess));

        if (guess == currentPlaylist)
        {
            correctSongsPlayed += songsPlayed;
            correctGuesses++;
        }
    }

    double correctRate = (double)correctGuesses / (double)GUESS_ROUNDS;

    cout<<"correctRate = "<<correctRate<<endl;

    if (correctRate < p)
        setResult("Accuracy too low: " + std::to_string(correctRate));

    double songsPlayedRate = (double)correctSongsPlayed / (double)correctGuesses;

    setResult("OK " + std::to_string(songsPlayedRate));

    return 0;
}
*/
