#include<bits/stdc++.h>
using namespace std;

const int nmax=50*50*50+42,C=50;

vector<int> adj[nmax];

struct edge
{
    int to,flow;
};
vector<edge> all;

int source=50*50*50;
int sink=source+1;

bool in(int x)
{
    return 0<=x&&x<C;
}
int hsh(int x,int y,int z)
{
    if(in(x)&&in(y)&&in(z))return (x*50+y)*50+z;
    return sink;
}
void add_edge(int x1,int y1,int z1,int x2,int y2,int z2,int cost)
{
    int p=(x1*C+y1)*C+z1;
    int q=hsh(x2,y2,z2);

    if(p==sink||q==source)return;

    edge me;

    me.to=q;
    me.flow=cost;

    adj[p].push_back(all.size());
    all.push_back(me);

    me.to=p;
    me.flow=0;

    adj[q].push_back(all.size());
    all.push_back(me);
}

int dist[nmax];

queue< pair<int,int> > q,idle;

bool bfs()
{
    memset(dist,-1,sizeof(dist));

    q=idle;

    q.push({source,0});

    while(q.size())
    {
        pair<int,int> tp=q.front();

        q.pop();

        if(dist[tp.first]!=-1)continue;

        dist[tp.first]=tp.second;

        if(tp.first==sink)return 1;

        for(auto w:adj[tp.first])
            if(all[w].flow)
                q.push({all[w].to,tp.second+1});
    }

    return 0;
}

int id[nmax];

bool dfs(int node)
{
    //cout<<"dfs "<<node<<endl;

    if(node==sink)return 1;

    while(id[node]<adj[node].size())
    {
        int w=adj[node][id[node]];

        id[node]++;

        if(all[w].flow)
        {
            if(dfs(all[w].to))
            {
                all[w].flow--;
                all[w^1].flow++;
                return 1;
            }
        }
    }

    return 0;
}

int cut()
{
    int ret=0;

    while(bfs())
    {
        memset(id,0,sizeof(id));

        while(dfs(source))ret++;
    }

    return ret;
}

int main()
{
    for(int x=0;x<C;x++)
        for(int y=0;y<C;y++)
            for(int z=0;z<C;z++)
            {
                add_edge(x,y,z,x+1,y,z,1);
                add_edge(x,y,z,x-1,y,z,1);
                add_edge(x,y,z,x,y+1,z,1);
                add_edge(x,y,z,x,y-1,z,1);
                add_edge(x,y,z,x,y,z+1,1);
                add_edge(x,y,z,x,y,z-1,1);
            }

    int n;
    scanf("%i",&n);

    for(int i=1;i<=n;i++)
    {
        int x,y,z;

        scanf("%i%i%i",&x,&y,&z);

        add_edge(C,0,0,x,y,z,1e9);
    }

    printf("%i\n",cut());

    return 0;
}
