#include <iostream>
#include <vector>

#define ENDL '\n'
#define INF 100000

namespace {
template<class T>
using vec = std::vector<T>;

template<class T>
using mat = vec<vec<T>>;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    mat<int> adjacency_matrix(n, vec<int>(n, 1));
    for (auto i = 0; i < n; ++i) {
        adjacency_matrix[i][i] = 0;
    }

    int a, b;
    while (m--) {
        std::cin >> a >> b;

        adjacency_matrix[a][b] = INF;
        adjacency_matrix[b][a] = INF;
    }

    for (auto k = 0; k < n; ++k) {
        for (auto i = 0; i < n; ++i) {
            for (auto j = 0; j < n; ++j) {
                adjacency_matrix[i][j] = std::min(adjacency_matrix[i][j], adjacency_matrix[i][k] + adjacency_matrix[k][j]);
            }
        }
    }

    int q;
    std::cin >> q;

    while (q--) {
        std::cin >> a >> b;

        auto res = adjacency_matrix[a][b];
        std::cout << (res < INF ? res : -1) << ENDL;
    }

    return 0;
}
