#include <iostream>
#include <queue>
#include <unordered_map>

#define ENDL '\n'
#define INF 100000

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    std::unordered_multimap<int, int> not_adjacent;

    int a, b;
    while (m--) {
        std::cin >> a >> b;
        if (a > b) {
            std::swap(a, b);
        }

        not_adjacent.emplace(a, b);
    }

    auto is_not_adjacent = [&](int x, int y) {
        if (x > y) {
            std::swap(x, y);
        }

        auto eq = not_adjacent.equal_range(x);
        for (auto it = eq.first; it != eq.second; ++it) {
            if (y == it->second) {
                return true;
            }
        }

        return false;
    };


    int q;
    std::cin >> q;

    while (q--) {
        std::cin >> a >> b;

        std::queue<std::pair<int, int>> q;
        q.emplace(a, 0);

        std::vector<bool> v(n);

        int res = -1;
        while (!q.empty()) {
            int p, d;
            std::tie(p, d) = q.front();
            q.pop();

            if (v[p]) {
                continue;
            }

            v[p] = true;
            if (p == b) {
                res = d;
                break;
            }

            for (auto i = 0; i < n; ++i) {
                if (is_not_adjacent(p, i)) {
                    continue;
                }

                q.emplace(i, d + 1);
            }
        }
        std::cout << res << ENDL;
    }

    return 0;
}
