#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

const int MAXN = 2503;

int n, m, q;
vector<int> g[MAXN];
int dist[MAXN][MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= m; ++ i)
    {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    for (int i = 0; i < n; ++ i)
    {
        sort(g[i].begin(), g[i].end());
        for (int j = 0; j < n; ++ j)
        {
            dist[i][j] = -1;
        }
    }
}

void BFS(int u)
{
    int start = u;
    queue<int> q;
    dist[u][u] = 0;
    q.push(u);

    while (!q.empty())
    {
        u = q.front();
        q.pop();

        int pos = 0;
        for (int i = 0; i < n; ++ i)
        {
            if (pos != g[u].size() and i == g[u][pos])
            {
                pos++;
                continue;
            }
            if (dist[start][i] == -1)
            {
                dist[start][i] = dist[start][u] + 1;
                q.push(i);
            }
        }
    }
}

int main()
{
    Init();

    for (int i = 0; i < n; ++ i)
    {
        BFS(i);
    }

    cin >> q;
    for (int i = 1; i <= q; ++ i)
    {
        int c, d;
        cin >> c >> d;
        cout << dist[c][d] << '\n';
    }

    return 0;
}
