#include "playlists.h"
#include <random>
#include <set>
#include <iostream>
#include <algorithm>
#include <map>
using namespace std;

int n, k, s;
double p;
vector<vector<int>> v;

mt19937 rg(4209008);

map<pair<int, int>, int> mp1;
map<int, pair<int, int>> mp2;

vector<vector<int>> makePlaylists(int N, int K, int S, double P)
{
    n = N;
    k = K;
    s = S;
    p = P;

    int cnt = 0;
    for (int i = 0; i < s; ++ i)
    {
        for (int j = i; j < s; ++ j)
        {
            mp1[make_pair(i, j)] = cnt;
            mp2[cnt] = make_pair(i, j);
            cnt++;
        }
    }

    for (int i = 0; i < n; ++ i)
    {
        v.emplace_back();
        for (int j = 0; j < k / 2; ++ j)
        {
            v[i].emplace_back(mp2[i % cnt].first);
        }
        for (int j = k / 2; j < k; ++ j)
        {
            v[i].emplace_back(mp2[i % cnt].second);
        }
        sort(v[i].begin(), v[i].end());
    }

    /*for (int i = 0; i < n; ++ i)
    {
        cout << "songs for " << i << ":\n";
        for (int j = 0; j < v[i].size(); ++ j)
        {
            cout << v[i][j] << ' ';
        }
        cout << endl;
    }//*/

    return v;
}

int guessPlaylist()
{
    bool prob = 0;
    set<int> songs;

    for (int i = 1; i <= k; ++ i)
    {
        int s1 = nextSong();
        int s2 = nextSong();
        int s3 = nextSong();
        int ss1 = min(s1, min(s2, s3));
        int ss2 = max(s1, max(s2, s3));
        return mp1[make_pair(ss1, ss2)];
        songs.insert(nextSong());

        int cnt = 0, pln = 0;

        for (int j = 0; j < n; ++ i)
        {
            int pos = -1;
            for (int ele : songs)
            {
                pos++;
                while (pos < k and ele != v[j][pos]) pos++;
                if (pos == k) break;
            }
            if (pos != k)
            {
                cnt++;
                pln = j;
            }
        }

        if (1.0 / cnt > p or i == k)
        {
            return pln;
        }
    }
}

/*
int main()
{
    makePlaylists(6, 3, 4, 0.5);
}
*/
