#include<iostream>
#include<cstdio>
#include<algorithm>
#include<stack>
#include<queue>
#include<map>
#include<set>

using namespace std;

set<pair<int, int> > missing;

map<pair<int, int>, int> foundBest;

vector<vector<int> > edges;

int n, m, q;


void input();

void solve(int c, int d)
{
    if (c > d) swap(c, d);

    if (foundBest.find(make_pair(c, d)) != foundBest.end())
    {
        return;
    }

    //cout<<c<<" vv "<<d<<endl;

    int ans = 0;

    queue<int> q;
    q.push(c);

    bool checked[n];
    for (int i=0; i<n; i++) checked[i] = false;
    checked[c] = true;

    int lastOfRound = c;
    int last;

    foundBest[make_pair(c, d)] = -1;

    //cout<<"Starting: "<<c<<endl;

    while (!q.empty())
    {
        int top = q.front();
        q.pop();

        //cout<<"Cur top: "<<top<<endl;

        foundBest[make_pair(min(c, top), max(c, top))] = ans;

        //cout<<"Set best: ("<<min(c, top)<<", "<<max(c, top)<<") = "<<ans<<endl;

        for (int i=0; i<edges[top].size(); i++)
        {
            if (!checked[edges[top][i]])
            {
                checked[edges[top][i]] = true;
                q.push(edges[top][i]);
                last = edges[top][i];
            }
        }

        if (top == lastOfRound)
        {
            ans++;
            lastOfRound = last;
        }
    }
}

int main()
{
    input();
}

void input()
{
    scanf("%d%d", &n, &m);
    edges.resize(n);

    for (int i=0; i<m; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);

        if (a > b) swap(a, b);
        missing.emplace(a, b);
    }

    for (int i=0; i<n-1; i++)
    {
        for (int j=i+1; j<n; j++)
        {
            if (missing.count(make_pair(i, j)) == 0)
            {
                edges[i].push_back(j);
                edges[j].push_back(i);

                //cout<<"Edge: "<<i<<" "<<j<<endl;
            }
        }
    }

    scanf("%d", &q);

    for (int i=0; i<q; i++)
    {
        int c, d;
        scanf("%d%d", &c, &d);
        if (c > d) swap(c, d);

        if (c == d) {printf("%s", "0\n"); continue;}
        if (missing.count(make_pair(c, d)) == 0) {printf("%s", "1\n"); continue;}

        solve(c, d);
        printf("%d%c", foundBest[make_pair(c, d)], '\n');
    }
}
