#include<iostream>
#include<cstdio>
#include<algorithm>
#include<stack>
#include<queue>
#include<map>
#include<set>

#include"playlists.h"

int N, K, S, P;

//combinations of s/2 songs
int c;

//different frequencies
int f;

int bestComps(int x)
{
    int ret = 1;
    for (int i=1; i<=x/2; i++) ret = (ret*(x-i))/i;
    return ret;
}
int MathChoose(int x, int y)
{
    int ret = 1;
    for(int i=x; i>x-y; i--) ret = ret*i/(x-i+1);
    return ret;
}

//tuples that will be the different songs per playlist
std::vector<std::vector<int> > tuples;

void generateTuples(std::vector<int> curTuple, int lastNum)
{
    //S-(S/2-curTuple.size()-1)
    for (int i=lastNum+1; i<S-(S/2-curTuple.size()-1); i++)
    {
        if (tuples.size() == N) return;
        //std::cout<<lastNum<<" "<<i<<std::endl;

        std::vector<int> next = curTuple;
        next.push_back(i);

        if (next.size() == S/2)
        {
            tuples.push_back(next);
        }
        else
        {
            generateTuples(next, i);
        }
        if (tuples.size() == N) return;
    }
}

std::vector<std::vector<int>> makePlaylists(int n, int k, int s, double p)
{
    N = n;
    K = k;
    S = s;
    P = p;

    c = MathChoose(s, s/2);
    //std::cout<<c<<std::endl;
    f = (n+c-1)/c;
    //std::cout<<f<<std::endl;

    if (f >= 3) std::cout<<"KILL IT";

    generateTuples(std::vector<int>(), -1);

//    for (int i=0; i<tuples.size(); i++)
//    {
//        for (int j=0; j<tuples[i].size(); j++) std::cout<<tuples[i][j]<<" ";
//        std::cout<<"\n";
//    }

    std::vector<int> amountOfEach;

    for (int i=0; i<(S/2); i++)
    {
        amountOfEach.push_back(K/(S/2));
        if (i < K%(S/2)) amountOfEach[i]++;
    }

    std::vector<std::vector<int> > ret;

    for (int i=0; i<N; i++)
    {
        std::vector<int> cur;

        for (int j=0; j<tuples[i/f].size(); j++)
        {
            for (int vv=0; vv<amountOfEach[j]; vv++) cur.push_back(tuples[i/f][j]);
        }

        ret.push_back(cur);
    }

//    for (int i=0; i<ret.size(); i++)
//    {
//        for (int j=0; j<ret[i].size(); j++) std::cout<<ret[i][j]<<" ";
//        std::cout<<"\n";
//    }

    return ret;
}

int guessPlaylist()
{
    std::set<int> uniqueSongs;

    while (uniqueSongs.size() < S/2)
    {
        uniqueSongs.insert(nextSong());
    }

    std::vector<int> sheet;

    for (auto x : uniqueSongs) sheet.push_back(x);

    for (int i=0; i<tuples.size(); i++)
    {
        if (sheet == tuples[i])
        {
            if (f == 2) return i*f+1-rand()%2;
            return i*f;
        }
    }
}

//int main()
//{
//    makePlaylists(46, 14, 8, 0.6);
//}
