#include<iostream>
#include<cstdio>
#include<algorithm>
#include<stack>
#include<queue>
#include<map>
#include<set>

using namespace std;

struct Cube
{
    int x, y, z;
    Cube() {x = y = z = 0;}
    Cube(int a, int b, int c) {x = a; y = b; z = c;}

    bool operator<(Cube a) const
    {
        if (this->x != a.x) return this->x < a.x;
        if (this->y != a.y) return this->y < a.y;
        return this->z < a.z;
    }
};

set<Cube> boxes;

int n;
int curAns = 0;

int lowerX=999999, lowerY=999999, lowerZ=999999, upperX=-999999, upperY=-999999, upperZ=-999999;

void input();
int main()
{
    input();

    for (auto cb : boxes)
    {
        curAns+=6;
        if (boxes.count(Cube(cb.x-1, cb.y, cb.z)) > 0) curAns--;
        if (boxes.count(Cube(cb.x+1, cb.y, cb.z)) > 0) curAns--;
        if (boxes.count(Cube(cb.x, cb.y-1, cb.z)) > 0) curAns--;
        if (boxes.count(Cube(cb.x, cb.y+1, cb.z)) > 0) curAns--;
        if (boxes.count(Cube(cb.x, cb.y, cb.z-1)) > 0) curAns--;
        if (boxes.count(Cube(cb.x, cb.y, cb.z+1)) > 0) curAns--;

        if (cb.x > upperX) upperX = cb.x;
        if (cb.x < lowerX) lowerX = cb.x;
        if (cb.y > upperY) upperY = cb.y;
        if (cb.y < lowerY) lowerY = cb.y;
        if (cb.z > upperZ) upperZ = cb.z;
        if (cb.z < lowerZ) lowerZ = cb.z;
    }

    bool cont = true;

    set<Cube> candidates;

    for (auto cb : boxes)
    {
        if (boxes.count(Cube(cb.x+1, cb.y, cb.z)) == 0 && candidates.count(Cube(cb.x+1, cb.y, cb.z)) == 0)
            candidates.emplace(cb.x+1, cb.y, cb.z);
        if (boxes.count(Cube(cb.x-1, cb.y, cb.z)) == 0 && candidates.count(Cube(cb.x-1, cb.y, cb.z)) == 0)
            candidates.emplace(cb.x-1, cb.y, cb.z);
        if (boxes.count(Cube(cb.x, cb.y+1, cb.z)) == 0 && candidates.count(Cube(cb.x, cb.y+1, cb.z)) == 0)
            candidates.emplace(cb.x, cb.y+1, cb.z);
        if (boxes.count(Cube(cb.x, cb.y-1, cb.z)) == 0 && candidates.count(Cube(cb.x, cb.y-1, cb.z)) == 0)
            candidates.emplace(cb.x, cb.y-1, cb.z);
        if (boxes.count(Cube(cb.x, cb.y, cb.z+1)) == 0 && candidates.count(Cube(cb.x, cb.y, cb.z+1)) == 0)
            candidates.emplace(cb.x, cb.y, cb.z+1);
        if (boxes.count(Cube(cb.x, cb.y, cb.z-1)) == 0 && candidates.count(Cube(cb.x, cb.y, cb.z-1)) == 0)
            candidates.emplace(cb.x, cb.y, cb.z-1);
    }


    while (cont == true)
    {
        cont = false;

        vector<Cube> futureCand;

        for (auto cand : candidates)
        {
            int surroundings = 0;

            if (boxes.count(Cube(cand.x+1, cand.y, cand.y)) > 0) surroundings++;
            if (boxes.count(Cube(cand.x-1, cand.y, cand.y)) > 0) surroundings++;
            if (boxes.count(Cube(cand.x, cand.y+1, cand.y)) > 0) surroundings++;
            if (boxes.count(Cube(cand.x, cand.y-1, cand.y)) > 0) surroundings++;
            if (boxes.count(Cube(cand.x, cand.y, cand.y+1)) > 0) surroundings++;
            if (boxes.count(Cube(cand.x, cand.y, cand.y-1)) > 0) surroundings++;

            if (surroundings >= 3)
            {
                boxes.emplace(cand.x, cand.y, cand.z);

                candidates.erase(cand);

                if (boxes.count(Cube(cand.x+1, cand.y, cand.z)) == 0) futureCand.emplace_back(cand.x+1, cand.y, cand.z);
                if (boxes.count(Cube(cand.x-1, cand.y, cand.z)) == 0) futureCand.emplace_back(cand.x-1, cand.y, cand.z);
                if (boxes.count(Cube(cand.x, cand.y+1, cand.z)) == 0) futureCand.emplace_back(cand.x, cand.y+1, cand.z);
                if (boxes.count(Cube(cand.x, cand.y-1, cand.z)) == 0) futureCand.emplace_back(cand.x, cand.y-1, cand.z);
                if (boxes.count(Cube(cand.x, cand.y, cand.z+1)) == 0) futureCand.emplace_back(cand.x, cand.y, cand.z+1);
                if (boxes.count(Cube(cand.x, cand.y, cand.z-1)) == 0) futureCand.emplace_back(cand.x, cand.y, cand.z-1);

                curAns += 3 - surroundings;
                cont = true;
            }
        }

        for (int i=0; i<futureCand.size(); i++)
            candidates.insert(futureCand[i]);
    }

    cout<<curAns<<endl;
}

void input()
{
    scanf("%d", &n);

    for (int i=0; i<n; i++)
    {
        int x, y, z;
        scanf("%d%d%d", &x, &y, &z);
        boxes.emplace(x, y, z);
    }
}
