#include<iostream>
#include<cstdio>
#include<algorithm>
#include<stack>
#include<queue>
#include<map>
#include<set>

using namespace std;

struct Cube
{
    short x, y, z;
    Cube() {x = y = z = 0;}
    Cube(short a, short b, short c) {x = a; y = b; z = c;}

    bool operator<(Cube a) const
    {
        if (this->x != a.x) return this->x < a.x;
        if (this->y != a.y) return this->y < a.y;
        return this->z < a.z;
    }
};

set<Cube> boxes;

int n;
int curAns = 0;

short lowerX=9999, lowerY=9999, lowerZ=9999, upperX=-9999, upperY=-9999, upperZ=-9999;

void input();
int main()
{
    input();

    set<Cube> candidates;

    for (auto cb : boxes)
    {
        curAns+=6;
        if (boxes.count(Cube(cb.x-1, cb.y, cb.z)) > 0) curAns--;
        else candidates.emplace(cb.x-1, cb.y, cb.z);

        if (boxes.count(Cube(cb.x+1, cb.y, cb.z)) > 0) curAns--;
        else candidates.emplace(cb.x+1, cb.y, cb.z);

        if (boxes.count(Cube(cb.x, cb.y-1, cb.z)) > 0) curAns--;
        else candidates.emplace(cb.x, cb.y-1, cb.z);

        if (boxes.count(Cube(cb.x, cb.y+1, cb.z)) > 0) curAns--;
        else candidates.emplace(cb.x, cb.y+1, cb.z);

        if (boxes.count(Cube(cb.x, cb.y, cb.z-1)) > 0) curAns--;
        else candidates.emplace(cb.x, cb.y, cb.z-1);

        if (boxes.count(Cube(cb.x, cb.y, cb.z+1)) > 0) curAns--;
        else candidates.emplace(cb.x, cb.y, cb.z+1);

        if (cb.x > upperX) upperX = cb.x;
        if (cb.x < lowerX) lowerX = cb.x;
        if (cb.y > upperY) upperY = cb.y;
        if (cb.y < lowerY) lowerY = cb.y;
        if (cb.z > upperZ) upperZ = cb.z;
        if (cb.z < lowerZ) lowerZ = cb.z;
    }


    //cout<<curAns<<endl;

    bool cont = true;

    //cout<<candidates.size()<<endl;

    while (cont == true)
    {
        cont = false;

        vector<Cube> futureCand;

        for (auto cand : candidates)
        {
            int surroundings = 0;

            if (boxes.count(Cube(cand.x+1, cand.y, cand.z)) > 0) surroundings++;
            if (boxes.count(Cube(cand.x-1, cand.y, cand.z)) > 0) surroundings++;
            if (boxes.count(Cube(cand.x, cand.y+1, cand.z)) > 0) surroundings++;
            if (boxes.count(Cube(cand.x, cand.y-1, cand.z)) > 0) surroundings++;
            if (boxes.count(Cube(cand.x, cand.y, cand.z+1)) > 0) surroundings++;
            if (boxes.count(Cube(cand.x, cand.y, cand.z-1)) > 0) surroundings++;

            if (surroundings >= 3)
            {
                boxes.emplace(cand.x, cand.y, cand.z);

                if (boxes.count(Cube(cand.x+1, cand.y, cand.z)) == 0) futureCand.emplace_back(cand.x+1, cand.y, cand.z);
                if (boxes.count(Cube(cand.x-1, cand.y, cand.z)) == 0) futureCand.emplace_back(cand.x-1, cand.y, cand.z);
                if (boxes.count(Cube(cand.x, cand.y+1, cand.z)) == 0) futureCand.emplace_back(cand.x, cand.y+1, cand.z);
                if (boxes.count(Cube(cand.x, cand.y-1, cand.z)) == 0) futureCand.emplace_back(cand.x, cand.y-1, cand.z);
                if (boxes.count(Cube(cand.x, cand.y, cand.z+1)) == 0) futureCand.emplace_back(cand.x, cand.y, cand.z+1);
                if (boxes.count(Cube(cand.x, cand.y, cand.z-1)) == 0) futureCand.emplace_back(cand.x, cand.y, cand.z-1);

                curAns += 3 - surroundings;
                cont = true;
            }
        }

        candidates.clear();

        for (int i=0; i<futureCand.size(); i++)
        {
            if (boxes.count(futureCand[i]) == 0) candidates.insert(futureCand[i]);
        }
    }

    cout<<curAns<<endl;
    //cout<<boxes.size()<<endl;
}

void input()
{
    scanf("%d", &n);

    for (int i=0; i<n; i++)
    {
        int x, y, z;
        scanf("%d%d%d", &x, &y, &z);
        boxes.emplace(x, y, z);
    }
}

/**

61
0 1 0
1 0 0
1 2 0
2 0 0
2 2 0
3 0 0
3 2 0
4 0 0
4 2 0
5 0 0
5 2 0
6 0 0
6 2 0
7 0 0
7 2 0
8 0 0
8 2 0
9 0 0
9 2 0
10 0 0
10 2 0
11 0 0
11 2 0
12 0 0
12 2 0
13 0 0
13 2 0
14 0 0
14 2 0
15 0 0
15 2 0
16 0 0
16 2 0
17 0 0
17 2 0
18 0 0
18 2 0
19 0 0
19 2 0
20 0 0
20 2 0
21 0 0
21 2 0
22 0 0
22 2 0
23 0 0
23 2 0
24 0 0
24 2 0
25 0 0
25 2 0
26 0 0
26 2 0
27 0 0
27 2 0
28 0 0
28 2 0
29 0 0
29 2 0
30 0 0
30 2 0

*/
