#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back

#include "playlists.h"

using namespace std;

const int MAXN = 100 + 5;
int n, k, s;
double p;
int num;
vector<vector<int>> pl;
int wh[MAXN][MAXN];

vector<vector<int>> makePlaylists(int N, int K, int S, double P) {
    n = N, k = K, s = S, p = P;
    pl.resize(n);

    int calc = 1;
    int curr = 0;
    for (num = 1; num <= s; num++) {
        calc = calc*(s-num+1) / num;

        vector<int> p(num);
        for (int i=0; i<num; i++) {
            p[i] = i;
        }

        for (int i=0; i<calc; i++) {
            if (curr == n) {
                break;
            }

            pl[curr].resize(k);
            for (int z=0; z<k; z++) {
                pl[curr][z] = p[z%num];
            }

            for (int z=num-1; z>=0; z--) {
                p[z]++;
                if (p[z] < s) {
                    for (z = z+1; z<num; z++) {
                        p[z] = p[z-1]+1;
                    }
                    break;
                }
            }
            curr++;
        }
        if (curr == n) {
            break;
        }
    }

    for (int i=0; i<pl.size(); i++) {
            if (pl[i].size()!= k) {
                return {{-1}};
            }
        for (int j=0; j<pl[i].size(); j++) {
            wh[pl[i][j]][i]++;
        }
    }

    for (int i=0; i<pl.size(); i++) {
        cerr<<i<<" - ";
        for (int j=0; j<pl[i].size(); j++) {
            cerr<<pl[i][j]<<' ';
        }
        cerr<<endl;
    }
    cerr<<"done"<<endl;

    return pl;
}

int guessPlaylist() {
    list<int> cs;
    for (int i=0; i<n; i++) {
        cs.pb(i);
    }

    int ch = 0;
    vector<int> cnt(s);
    while (ch < k) {
        int curr = nextSong();
        cnt[curr]++;

        //cerr<<123<<endl;
        auto id = cs.begin();
        while (id != cs.end()) {
            auto id2 = id++;
            if (wh[curr][*id2] < cnt[curr]) {
                cs.erase(id2);
            }
        }
        if ((double)1 / cs.size() >= p) {
            //cerr<<*cs.begin()<<endl;
            return *cs.begin();
        }
        ch++;
    }
    return *cs.begin();
}
/*
16 4 4 0.5
*/

static std::mt19937 mt(42);

static const int GUESS_ROUNDS = 20000;

static void setResult(std::string message)
{
    std::cout << message << std::endl;
    exit(0);
}

static void input()
{
    std::cin >> n >> k >> s >> p;
}

static std::vector<std::vector<int>> playlists;

static void verifyPlaylists()
{
    if (playlists.size() != n)
        setResult("Wrong number of playlists: " + std::to_string(playlists.size()));

    for (std::vector<int> playlist : playlists)
    {
        if (playlist.size() != k)
            setResult("Wrong number of songs: " + std::to_string(playlist.size()));

        for (int song : playlist)
        {
            if (song < 0 || song >= s)
                setResult("Invalid song: " + std::to_string(song));
        }
    }
}

static int currentPlaylist;
static int currentSong;
static int songsPlayed = 0;
static int correctSongsPlayed = 0;

static void startNewPlaylist()
{
    currentPlaylist = mt() % n;
    currentSong = 0;
    shuffle(playlists[currentPlaylist].begin(), playlists[currentPlaylist].end(), mt);
    songsPlayed = 0;
}

int nextSong()
{
    songsPlayed++;

    if (currentSong >= k)
        setResult("Trying to play songs after playlist is over");

    int song = playlists[currentPlaylist][currentSong];
    currentSong++;

    return song;
}

int main()
{
    std::ios::sync_with_stdio(false);

    input();
    playlists = makePlaylists(n, k, s, p);
    verifyPlaylists();

    int correctGuesses = 0;
    for (int i = 0; i < GUESS_ROUNDS; i++)
    {
        startNewPlaylist();
        int guess = guessPlaylist();

        if (guess < 0 || guess >= n)
            setResult("Invalid guess: " + std::to_string(guess));

        if (guess == currentPlaylist)
        {
            correctSongsPlayed += songsPlayed;
            correctGuesses++;
        }
    }

    double correctRate = (double)correctGuesses / (double)GUESS_ROUNDS;

    if (correctRate < p)
        setResult("Accuracy too low: " + std::to_string(correctRate));

    double songsPlayedRate = (double)correctSongsPlayed / (double)correctGuesses;

    setResult("OK " + std::to_string(songsPlayedRate));

    return 0;
}



