#include <bits/stdc++.h>
#include "playlists.h"

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T &b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T &b){ a = (a > b) ? a : b; }
#define all(x) (x).begin(), (x).end()
int get_int();
ll get_ll();

int nextSong();
const int N = 100 + 3;

mt19937 mt(133);
vector<vector<int>> ans;

int f[N][N];
int n, k, s;
double p;

vector<vector<int>> makePlaylists(int _n, int _k, int _s, double _p){
    n = _n, k = _k, s = _s, p = _p;
    if(n == s){
        for(int i = 0; i < n; ++i){
            ans.push_back({});
            for(int j = 0; j < k; ++j)
                ans.back().push_back(i);
        }
        return ans;
    }

    for(int i = 0; i < n; ++i){
        vector<int> v;
        int cnt = k;
        vector<int> perm;
        for(int i = 0; i < s; ++i)
            perm.push_back(i);
        random_shuffle(all(perm), [&](int mod){
            return mt() % mod;
        });
        for(int idx: perm){
            if(!cnt) break;
            if(idx == perm.back()){
                f[i][idx] = cnt;
                break;
            }
            f[i][idx] = mt() % cnt + 1;
            cnt -= f[i][idx];
        }

        for(int j = 0; j < s; ++j){
            for(int j2 = 0; j2 < f[i][j]; ++j2)
                v.push_back(j);
            }
        ans.push_back(v);
    }
    return ans;
}

double cnt_win = 0, cnt_p = 0;
const int C = 2;

int guessPlaylist(){
    if(n == 1) return 0;
    if(n == s){
        return nextSong();
    }

    static int f2[N];
    fill(f2, f2 + s, 0);
    for(int i = 0; i < k / C + k % C; ++i)
        ++f2[nextSong()];
    int best = 0, diff = INT_MAX;
    for(int i = 0; i < n; ++i){
        bool ok = true;
        for(int j = 0; j < s; ++j)
        if(f[i][j] < f2[j]){
            ok = false;
            break;
        }
        if(!ok) continue;
        int curr_diff = 0;
        for(int j = 0; j < s; ++j)
            curr_diff += abs(f[i][j] - f2[j] * C);
        if(curr_diff < diff){
            best = i;
            diff = curr_diff;
        }
    }
    return best;
}

