#include <bits/stdc++.h>
using namespace std;
#define endl "\n"
typedef long long ll;
template<class T, class T2> bool chkmax(T &a, const T2 &b) {return (a < b) ? a = b, 1 : 0;}
template<class T, class T2> bool chkmin(T &a, const T2 &b) {return (a > b) ? a = b, 1 : 0;}
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")
struct Edge {
    int to, flow, cap;
    Edge() {}
    Edge(int a, int b, int c) {to = a; flow = b; cap = c;}
};
const int MAX_CORD = 52, MAX_N = MAX_CORD * MAX_CORD * MAX_CORD + 10;
struct FlowNetwork {
    vector<Edge> edges;
    vector<int> g[MAX_N];
    int dist[MAX_N], ind[MAX_N];
    int s, t;
    void addEdge(int a, int b, int cap = 1) {
        g[a].push_back(edges.size());
        edges.emplace_back(b, 0, cap);
        g[b].push_back(edges.size());
        edges.emplace_back(a, 0, cap);
    }
    bool bfs() {
        for(int i = 0; i < MAX_N; i ++) {
            dist[i] = -1;
            ind[i] = 0;
        }
        dist[s] = 0;
        queue<int> q;
        q.push(s);
        while(!q.empty()) {
            auto curr = q.front(); q.pop();
            for(auto it : g[curr]) {
                if(edges[it].flow < edges[it].cap && dist[edges[it].to] == -1) {
                    dist[edges[it].to] = dist[curr] + 1;
                    q.push(edges[it].to);
                }
            }
        }
        return dist[t] != -1;
    }
    int dfs(int x, int val) {
        if(x == t || val == 0) {return val;}
        for(; ind[x] < g[x].size();) {
            int it = g[x][ind[x]];
            ind[x] ++;
            if(dist[x] != dist[edges[it].to] - 1 || edges[it].flow >= edges[it].cap) {continue;}
            int fl = dfs(edges[it].to, min(val, edges[it].cap - edges[it].flow));
            if(fl == 0) {continue;}
            edges[it].flow += fl;
            edges[it ^ 1].flow -= fl;
            //cout << "Using flow" << edges[it].to << " " << edges[it ^ 1].to << endl;
            return fl;
        }
        return 0;
    }
    int maxFlow() {
        int ret = 0;
        while(bfs()) {
            int fl;
            while(fl = dfs(s, 1e9)) {
                //cout << "Got" << fl << endl;
                ret += fl;
            }
        }
        return ret;
    }
};
FlowNetwork fn;
void printc(int h) {
    return;
    cout << h / MAX_CORD / MAX_CORD << " " << (h / MAX_CORD) % MAX_CORD << " " << h % MAX_CORD << endl;
}
int hsh(int a, int b, int c) {
    return a * MAX_CORD * MAX_CORD + b * MAX_CORD + c;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    for(int i = 0; i < n; i ++) {
        int x, y, z;
        cin >> x >> y >> z;
        fn.addEdge(MAX_N - 2, hsh(x + 1, y + 1, z + 1), 1e9);
    }
    for(int i = 0; i < MAX_CORD; i ++) {
        for(int j = 0; j < MAX_CORD; j ++) {
            for(int k = 0; k < MAX_CORD; k ++) {
                if((i + j + k) % 2 == 0) {
                    if(i > 0) {fn.addEdge(hsh(i, j, k), hsh(i - 1, j, k));}
                    if(j > 0) {fn.addEdge(hsh(i, j, k), hsh(i, j - 1, k));}
                    if(k > 0) {fn.addEdge(hsh(i, j, k), hsh(i, j, k - 1));}
                    if(i < MAX_CORD - 1) {fn.addEdge(hsh(i, j, k), hsh(i + 1, j, k));}
                    if(j < MAX_CORD - 1) {fn.addEdge(hsh(i, j, k), hsh(i, j + 1, k));}
                    if(k < MAX_CORD - 1) {fn.addEdge(hsh(i, j, k), hsh(i, j, k + 1));}
                }
            }
        }
    }
    for(int i = 0; i < MAX_CORD; i ++) {
        for(int j = 0; j < MAX_CORD; j ++) {
            fn.addEdge(MAX_N - 1, hsh(i, j, 0), 1e9);
            fn.addEdge(MAX_N - 1, hsh(i, j, MAX_CORD - 1), 1e9);
            fn.addEdge(MAX_N - 1, hsh(i, 0, j), 1e9);
            fn.addEdge(MAX_N - 1, hsh(i, MAX_CORD - 1, j), 1e9);
            fn.addEdge(MAX_N - 1, hsh(0, i, j), 1e9);
            fn.addEdge(MAX_N - 1, hsh(MAX_CORD - 1, i, j), 1e9);
        }
    }
    fn.s = MAX_N - 2;
    fn.t = MAX_N - 1;
    cout << fn.maxFlow();
    return 0;
}
/*
4
0 1 0
1 0 0
2 1 0
1 2 0
*/
