#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>
#define endl '\n'
#define BIG 1000000000
using namespace std;


vector<tuple<int, int, int>> edges;
int N, M;

int BellmanFordShortestPath(int firstNode, int lastNode) {
    int distance[N];
    for (int i = 0; i < N; i++) distance[i] = BIG;
    distance[firstNode] = 0;

    for (int i = 0; i < N - 1; i++) {
        for (auto e: edges) {
            int a, b, w;
            tie(a, b, w) = e;
            distance[b] = min(distance[b], distance[a] + w);
        }
    }

    int output = distance[lastNode];
    if (output != BIG) {
        return output;
    } else {
        return -1;
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    vector<pair<int, int>> broken;
    cin >> N >> M;

    for (int i = 0, x, y; i < M; i++) {
        cin >> x >> y;
        broken.push_back({x, y});
        broken.push_back({y, x});
    }
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            if (i == j || find(broken.begin(), broken.end(), make_pair(i, j)) != broken.end()) continue;

            edges.push_back({i, j, 1});
        }
    }

    int Q;
    cin >> Q;
    vector<int> ans;

    for (int i = 0, f, l; i < Q; i++) {
        cin >> f >> l;
        ans.push_back(BellmanFordShortestPath(f, l));
    }

    for (auto i: ans) {
        cout << i << endl;
    }

    return 0;
}
