#include <iostream>
#include <vector>
#define endl '\n'
#define BIG 1000000000
using namespace std;


int graph[10000][10000];
int N, M;

int BellmanFordShortestPath(int firstNode, int lastNode) {
    int distance[N];
    for (int i = 0; i < N; i++) distance[i] = BIG;
    distance[firstNode] = 0;

    for (int i = 0; i < N - 1; i++) {
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                if (i == j || graph[i][j] == 1) continue;

                distance[j] = min(distance[j], distance[i] + 1);
                if (distance[lastNode] != BIG) {
                    return distance[lastNode];
                }
            }
        }
    }

    return -1;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> N >> M;

    for (int i = 0, x, y; i < M; i++) {
        cin >> x >> y;
        graph[x][y] = 1;
        graph[y][x] = 1;
    }

    int Q;
    cin >> Q;
    vector<int> ans;

    for (int i = 0, f, l; i < Q; i++) {
        cin >> f >> l;
        ans.push_back(BellmanFordShortestPath(f, l));
    }

    for (auto i: ans) {
        cout << i << endl;
    }

    return 0;
}
