#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;


int graph[10000][10000];
int N, M;

int bfs(int firstNode, int lastNode, bool visited[]) {
    int ans;

    int distance[N];
    distance[firstNode] = 0;

    queue<int> q;
    q.push(firstNode);
    visited[firstNode] = true;

    while(!q.empty()) {
        int node = q.front(); q.pop();

        for (int i = 0; i < N; i++) {
            if (i == node) continue;
            if (graph[node][i]) continue;
            if (visited[i]) continue;

            distance[i] = distance[node] + 1;
            if (i == lastNode) {
                return distance[i];
            }

            visited[i] = true;
            q.push(i);
        }
    }

    if (!visited[lastNode]) {
        return -1;
    } else {
        return distance[lastNode];
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> N >> M;

    for (int i = 0, x, y; i < M; i++) {
        cin >> x >> y;
        graph[x][y] = 1;
        graph[y][x] = 1;
    }

    int Q;
    cin >> Q;
    vector<int> ans;
    bool visited[N] = {false};

    for (int i = 0, f, l; i < Q; i++) {
        cin >> f >> l;
        ans.push_back(bfs(f, l, visited));
    }

    for (auto i: ans) {
        cout << i << endl;
    }

    return 0;
}
