#include<iostream>
#include<vector>
#include<utility>
#include<queue>
#include<algorithm>
using namespace std;

const int Inf=999999999;
const int Max_N=10010;

int n,m,q;

vector< pair<int,int> > que;

// from - to

int adj_mat [Max_N][Max_N];

void init_adj_mat(){
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            if(i==j){
                adj_mat[i][j]=0;
            }else{
                adj_mat[i][j]=1;
            }
        }
    }
}

void calc_floyd_warshall(){
    for(int k=0;k<n;k++){
        for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                adj_mat[i][j]=min(adj_mat[i][j],adj_mat[i][k]+adj_mat[k][j]);
            }
        }
    }
    return;
}

void answer_queries(){
    int curr_res;
    for(int i=0;i<q;i++){
        curr_res=adj_mat[que[i].first][que[i].second];
        if(curr_res>=Inf){
            cout<<"-1"<<endl;
        }else{
            cout<<curr_res<<endl;
        }
    }
    return;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin>>n>>m;
    int a,b;
    init_adj_mat();
    for(int i=0;i<m;i++){
        cin>>a>>b;
        adj_mat[a][b]=Inf;
        adj_mat[b][a]=Inf;
    }
    cin>>q;
    que.resize(q);
    for(int i=0;i<q;i++){
        cin>>a>>b;
        que[i].first=a;
        que[i].second=b;
    }
    calc_floyd_warshall();
    answer_queries();
    return 0;
}
