#include <iostream>
#include <cstring>
#include <bitset>
#include <queue>
#include <set>
#include <map>

using namespace std;

const int MAXN = 1e4 + 5;

int n;
bitset <MAXN> isRem[MAXN];
set <pair <int, int>> allRemoved;

int solveEz(int u, int v)
{
    if(u==v) return 0;
    if(allRemoved.count({u, v})==false)
        return 1;

    bitset <MAXN> curr = (isRem[u]|isRem[v]);

    for(int x = 0;x<n;x++)
    {
        if(curr[x]==0)
            return 2;
    }

    return -1;
}

int dist[MAXN];
int bfs(int startNode, int endNode)
{
    queue <int> q;
    memset(dist, -1, sizeof(dist));

    q.push(startNode);
    dist[startNode] = 0;

    while(q.empty()==false)
    {
        int x = q.front();
        q.pop();

        if(x==endNode)
            return dist[x];

        for(int y = 0;y<n;y++)
        {
            if(dist[y]==-1 && isRem[x][y]==0)
            {
                dist[y] = dist[x] + 1;
                q.push(y);
            }
        }
    }

    return -1;
}

map <pair <int, int>, int> answered;
int answerQuery(int u, int v)
{
    if(answered.count({u, v})==true)
        return answered[{u, v}];

    int ezAns = solveEz(u, v);
    if(ezAns!=-1) return ezAns;

    return bfs(u, v);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int m;
    cin >> n >> m;
    for(int i = 0;i<m;i++)
    {
        int x, y;
        cin >> x >> y;

        isRem[x][y] = 1;
        isRem[y][x] = 1;
        allRemoved.insert({x, y});
        allRemoved.insert({y, x});
    }

    int Q;
    cin >> Q;

    while(Q--)
    {
        int u, v;
        cin >> u >> v;
        if(u>v) swap(u, v);

        int ans = answerQuery(u, v);
        answered[{u, v}] = ans;
        answered[{v, u}] = ans;

        cout << ans << '\n';
    }
}
