#include <iostream>
#include <cstring>
#include <random>
#include <bitset>
#include <queue>
#include <set>
#include <map>

using namespace std;

mt19937 rnd(22);
const int MAXN = 705 + 5;

int n;
bitset <MAXN> isRem[MAXN];
bitset <MAXN> isActive[MAXN];
set <pair <int, int>> allRemoved;

bool isBlocked[MAXN];
vector <int> graph[MAXN];
vector <int> invGraph[MAXN];

int solveEz(int u, int v)
{
    if(u==v) return 0;
    if(allRemoved.count({u, v})==false)
        return 1;

    for(int x = 0;x<n;x++)
    {
        if(isActive[u][x]==true && isActive[x][v]==true)
            return 2;
    }

    bool found = false;
    for(int iter = 0;iter<10;iter++)
    {
        int x = rnd()%n;
        int y = rnd()%n;
        if(isRem[x][y]==1) continue;

        if(isActive[u][x]==1 && isActive[y][v]==1)
        {
            found = true;
            break;
        }
    }
    if(found==true)
        return 3;

    return -1;
}

int dist[MAXN][MAXN];
map <pair <int, int>, int> answered;

int bfs(int startNode)
{
    queue <int> q;

    q.push(startNode);
    dist[startNode][startNode] = 1;

    while(q.empty()==false)
    {
        int x = q.front();
        q.pop();

        for(int y: invGraph[x])
        {
            if(dist[startNode][y]==0)
            {
                dist[startNode][y] = dist[startNode][x] + 1;
                q.push(y);
            }
        }
    }

    return -1;
}


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int m;
    cin >> n >> m;

    for(int i = 0;i<n;i++)
        isActive[i].flip();

    for(int i = 0;i<m;i++)
    {
        int x, y;
        cin >> x >> y;

        isActive[x][y] = 0;
        isActive[y][x] = 0;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    for(int x = 0;x<n;x++)
    {
        for(int y = 0;y<n;y++)
        {
            if(isActive[x][y]==true)
                invGraph[x].push_back(y);
        }
    }

    for(int x = 0;x<n;x++)
    {
        bfs(x);
    }

    int Q;
    cin >> Q;

    while(Q--)
    {
        int u, v;
        cin >> u >> v;
        if(u>v) swap(u, v);

        cout << dist[u][v] - 1 << '\n';
    }
}
