#include <set>
#include <random>
#include <vector>
#include <iostream>

#include "playlists.h"
//#include "Lgrader.cpp"

using namespace std;

int n, k;
mt19937 rnd(22);

vector <vector <int>> playlists;
vector<vector<int>> makePlaylists(int _n, int _k, int s, double p)
{
    n = _n;
    k = _k;

    playlists.resize(n);
    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<k;j++)
            playlists[i].push_back(rnd()%s);
    }

    return playlists;
}

bool checkMatch(vector <int> &p, vector <int> &s)
{
    vector <int> allSongs(105, 0);
    for(int x: p)
        allSongs[x]++;

    for(int x: s)
    {
        allSongs[x]--;
        if(allSongs[x]<0) return false;
    }

    return true;
}

int getCntMatches(vector <int> &s)
{
    int cnt = 0;
    for(vector <int> &p: playlists)
    {
        if(checkMatch(p, s)==true) cnt++;
    }

    return cnt;
}

int getFirstMatch(vector <int> &s)
{
    int cnt = 0;
    for(int i = 0;i<playlists.size();i++)
    {
        if(checkMatch(playlists[i], s)==true)
            return i;
    }

    return -1;
}

int guessPlaylist()
{
    vector <int> s;
    do
    {
        s.push_back(nextSong());
    }
    while(s.size()<k && getCntMatches(s)!=1);

    return getFirstMatch(s);
}
