#include <set>
#include <random>
#include <vector>
#include <cstring>
#include <iostream>

#include "playlists.h"
#include "Lgrader.cpp"

using namespace std;

const int MAXN = 105;

int n, k;
mt19937 rnd(22);

bool isFail[MAXN];
int songsCnt[MAXN][MAXN];

vector <vector <int>> playlists;

vector<vector<int>> makePlaylists(int _n, int _k, int s, double p)
{
    n = _n;
    k = _k;

    playlists.resize(n);
    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<k;j++)
            playlists[i].push_back(rnd()%s);
    }

    return playlists;
}

int getCntMatches(int newS)
{
    int cnt = 0;
    for(int i = 0;i<playlists.size();i++)
    {
        if(isFail[i]==true) continue;

        songsCnt[i][newS]--;
        if(songsCnt[i][newS]<0)
        {
            isFail[i] = true;
            continue;
        }

        cnt++;
    }

    return cnt;
}

int getFirstMatch()
{
    int cnt = 0;
    for(int i = 0;i<playlists.size();i++)
    {
        if(isFail[i]==false)
            return i;
    }

    return -1;
}

int guessPlaylist()
{
    memset(songsCnt, 0, sizeof(songsCnt));
    memset(isFail, false, sizeof(isFail));

    for(int i = 0;i<playlists.size();i++)
    {
        isFail[i] = false;
        for(int x: playlists[i])
            songsCnt[i][x]++;
    }

    int s;
    int listened = 0;

    do
    {
        listened++;
        s = nextSong();
    }
    while(listened<k && getCntMatches(s)!=1);

    return getFirstMatch();
}
