#include <set>
#include <random>
#include <vector>
#include <cstring>
#include <iostream>
#include <algorithm>

#include "playlists.h"

#ifdef __LOCAL
#include "Lgrader.cpp"
#endif // __LOCAL

using namespace std;

const int MAXN = 105;

int n, k;
int _needed;

mt19937 rnd(22);
int randInRange(int l, int r)
{
    return l + rnd()%(r-l+1);
}

bool isFail[MAXN];
int songsCnt[MAXN][MAXN];

bool isDuplicate[MAXN];
vector <vector <int>> playlists;

void appendRand(vector <int> &v, int cnt, int l, int r)
{
    for(int i = 0;i<cnt;i++)
        v.push_back(randInRange(l, r));
}

int minVal[MAXN];
void rec(vector <int> &curr, int n, int k, int s, int last)
{
    if(playlists.size()==n) return;
    if(curr.size()==k)
    {
        playlists.push_back(curr);
        return;
    }

    for(int x = last;x<s;x++)
    {
        curr.push_back(x);
        rec(curr, n, k, s, last);
        curr.pop_back();
    }
}

vector <int> order;
vector <vector <int>> selections;

void yoanko(vector <int> &curr, vector <bool> &inCurr, int sz, int n, int s)
{
    if(selections.size()==3*n) return;
    if(curr.size()==sz)
    {
        selections.push_back(curr);
        return;
    }

    for(int x: order)
    {
        if(inCurr[x]==false)
        {
            inCurr[x] = true;
            curr.push_back(x);

            yoanko(curr, inCurr, sz, n, s);

            inCurr[x] = false;
            curr.pop_back();
        }
    }
}

vector<vector<int>> makePlaylists(int _n, int _k, int s, double p)
{
    n = _n;
    k = _k;
    _needed = ceil(2e4 * p);

    for(int x = 0;x<s;x++)
        order.push_back(x);

    vector <int> szs = {1, 11, 5};
    //for(int sz = 1;sz<=s;sz++)
    //    szs.push_back(sz);

    for(int sz: szs)
    {
        shuffle(order.begin(), order.end(), rnd);

        vector <int> curr;
        vector <bool> inCurr(105, false);

        yoanko(curr, inCurr, sz, n, s);
    }
    //shuffle(playlists.begin(), playlists.end(), rnd);

    if(double((n/s)+1)/double(n)-0.1>p)
    {
        playlists.resize(n);
        for(int i = 0;i<n;i++)
        {
            vector <int> &sel = selections[i%selections.size()];
            for(int j = 0;j<k;j++)
            {
                playlists[i].push_back((i)%s);
            }
            sort(playlists[i].begin(), playlists[i].end());
        }
    }
    else
    {
        playlists.resize(n);
        for(int i = 0;i<n;i++)
        {
            if(i<s)
            {
                for(int j = 0;j<k;j++)
                    playlists[i].push_back(i);
            }
            else
            {
                for(int j = 0;j<k;j++)
                    playlists[i].push_back(rnd()%s);
            }
        }
    }

    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<i;j++)
        {
            if(playlists[i]==playlists[j])
            {
                isDuplicate[i] = true;
                break;
            }
        }
    }

    return playlists;
}

int getCntMatches(int newS)
{
    int cnt = 0;
    for(int i = 0;i<playlists.size();i++)
    {
        if(isFail[i]==true) continue;

        if(newS!=-1)
        {
            songsCnt[i][newS]--;
            if(songsCnt[i][newS]<0)
            {
                isFail[i] = true;
                continue;
            }
        }

        cnt++;
    }

    return cnt;
}

int getFirstMatch()
{
    int cnt = 0;
    for(int i = 0;i<playlists.size();i++)
    {
        if(isFail[i]==false)
            return i;
    }

    return -1;
}

int guessPlaylist()
{
    //if(_needed<=0)
    //    return rnd()%playlists.size();

    memset(songsCnt, 0, sizeof(songsCnt));
    memset(isFail, false, sizeof(isFail));

    for(int i = 0;i<playlists.size();i++)
    {
        isFail[i] = isDuplicate[i];
        for(int x: playlists[i])
            songsCnt[i][x]++;
    }

    int s;
    int listened = 0;

    do
    {
        listened++;
        s = nextSong();
    }
    while(listened<k && getCntMatches(s)!=1);

    //if(getCntMatches(-1)==1)
    //    _needed--;

    return getFirstMatch();
}
