#include <bits/stdc++.h>
//#include "playlists.h"
using namespace std;

static int n, k, s;
static double p;
static std::mt19937 mt(42);

static const int GUESS_ROUNDS = 20000;

static void setResult(std::string message)
{
    std::cout << message << std::endl;
    exit(0);
}

static void input()
{
    std::cin >> n >> k >> s;
    p = 0.5;
}

static std::vector<std::vector<int>> playlists;

static void verifyPlaylists()
{
    if (playlists.size() != n)
        setResult("Wrong number of playlists: ");

    for (std::vector<int> playlist : playlists)
    {
        if (playlist.size() != k)
            setResult("Wrong number of songs: " + std::to_string(playlist.size()));

        for (int song : playlist)
        {
            if (song < 0 || song >= s)
                setResult("Invalid song: " + std::to_string(song));
        }
    }
}

static int currentPlaylist;
static int currentSong;
static int songsPlayed = 0;
static int correctSongsPlayed = 0;

static void startNewPlaylist()
{
    currentPlaylist = mt() % n;
    currentSong = 0;
    shuffle(playlists[currentPlaylist].begin(), playlists[currentPlaylist].end(), mt);
    songsPlayed = 0;
}

int nextSong()
{
    songsPlayed++;

    if (currentSong >= k)
        setResult("Trying to play songs after playlist is over");

    int song = playlists[currentPlaylist][currentSong];
    currentSong++;

    return song;
}

int lamp,sz;
int global_s,global_k,global_n;

vector<vector<int> >v;
map<vector<int>, int>mp;
vector<int>tv;

void combinations(int i,int last)
{
    if(i == global_k)
    {
        mp[tv] = v.size();
        v.push_back(tv);
        return;
    }

    int j;
    for(j=last; j<global_s; j++)
    {
        tv[i] = j;
        combinations(i+1,j);
    }
}

int cnt;
bool check(int i,int last,int range)
{
    if(i == global_k || cnt >= range)
    {
        cnt++;
        return true;
    }

    int j;
    for(j=last; j<global_s; j++)
    {
        if(cnt >= range)return true;
        check(i+1,j,range);
    }
    return true;
}

std::vector<std::vector<int> > makePlaylists(int n, int k, int s, double p)
{
    vector<vector<int> >ans;
    vector<int> t;

    int ss = s;
    if(check(0,0,n-1) && cnt>=n-1)s--;
    global_s = s;
    global_k = k;
    global_n = n;
    int dp = floor(n*p);
    if(ss > s)n = n - dp;

    int i=0,j,num = 0,cnt = 0;
    while(num < s && i<n && check(0,num+1,n-i-1) && cnt >= n-i-1)
    {
        t.clear();
        cnt = 0;
        lamp = i;

        for(j=0; j<k; j++)
            t.push_back(num);

        ans.push_back(t);
        num++; i++;
    }
    if(i >= n)
        goto label1;

    tv.resize(k);
    combinations(0,num);
    sz = i;

    for(i=i; i<n; i++)
        ans.push_back(v[i-sz]);

    label1:

    if(ss > s)
    {t.clear();
    for(j=0; j<k; j++)
        t.push_back(s);

    for(j=0; j<dp; j++)
        ans.push_back(t);}

    return ans;
}

bool cmp(int a,int b)
{
    return a<b;
}

int guessPlaylist()
{
    int song = nextSong();

    if(song == global_s)
        return global_n - 1;

    if(song <= lamp)
        return song;

    vector<int>t;
    t.push_back(song);

    int i;
    for(i=1; i<global_k; i++)
    {
        song = nextSong();
        t.push_back(song);
    }

    sort(t.begin(),t.end(),cmp);

    return mp[t] + sz;
}
int main()
{
    std::ios::sync_with_stdio(false);

    input();
    playlists = makePlaylists(n, k, s, p);
    verifyPlaylists();

    int correctGuesses = 0;
    for (int i = 0; i < GUESS_ROUNDS; i++)
    {
        startNewPlaylist();
        int guess = guessPlaylist();

        if (guess < 0 || guess >= n)
            setResult("Invalid guess: " + std::to_string(guess));

        if (guess == currentPlaylist)
        {
            correctSongsPlayed += songsPlayed;
            correctGuesses++;
        }
    }

    double correctRate = (double)correctGuesses / (double)GUESS_ROUNDS;

    if (correctRate < p)
        setResult("Accuracy too low: " + std::to_string(correctRate));

    double songsPlayedRate = (double)correctSongsPlayed / (double)correctGuesses;

    setResult("OK " );

    return 0;
}
