#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int INF = 1e9;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m;
vector<vector<int>> edgeMatrix;

void read() {
    cin >> n >> m;

    edgeMatrix.resize(n, vector<int>(n, 1));
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;

        edgeMatrix[u][v] = edgeMatrix[v][u] = INF;
    }
    for (int i = 0; i < n; i++) {
        edgeMatrix[i][i] = 0;
    }
}

void solve() {
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                edgeMatrix[i][j] = min(edgeMatrix[i][j], edgeMatrix[i][k] + edgeMatrix[k][j]);
            }
        }
    }

    int q;
    cin >> q;

    while (q--) {
        int u, v;
        cin >> u >> v;

        cout << (edgeMatrix[u][v] == INF ? -1 : edgeMatrix[u][v]) << endl;
    }
}

int main() {
    setIO();

    read();

    solve();
}
