#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int INF = 1e9;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m;
vector<vector<bool>> edgeMatrix;

void read() {
    cin >> n >> m;

    edgeMatrix.resize(n, vector<bool>(n, true));
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;

        edgeMatrix[u][v] = edgeMatrix[v][u] = false;
    }
}

vector<vector<int>> adjList;
vector<vector<int>> dist;

void bfs(int node) {
    queue<int> q;

    q.emplace(node);
    dist[node][node] = 0;

    while (!q.empty()) {
        int now = q.front();
        q.pop();

        for (int adjNode : adjList[now]) {
            if (dist[node][adjNode] == INF) {
                dist[node][adjNode] = dist[node][now] + 1;
                q.emplace(adjNode);
            }
        }
    }
}

void solve() {
    adjList.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (edgeMatrix[i][j]) {
                adjList[i].emplace_back(j);
                adjList[j].emplace_back(i);
            }
        }
    }

    dist.resize(n, vector<int>(n, INF));

    int q;
    cin >> q;

    while (q--) {
        int u, v;
        cin >> u >> v;

        if (dist[u][u] == INF && dist[v][v] < INF) {
            swap(u, v);
        }

        if (dist[u][u] == INF) {
            bfs(u);
        }

        cout << (dist[u][v] == INF ? -1 : dist[u][v]) << endl;
    }
}

int main() {
    setIO();

    read();

    solve();
}
