#include <bits/stdc++.h>
#include "playlists.h"

#pragma GCC optimize "-O3"

#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int NUM_ROUNDS = 20000;

int requiredRounds;
int N, K, S;
int numFound = 0;
vector<int> comb;
vector<vector<int>> playLists;

void bruteForce(int pos) {
    if (pos == K) {
        numFound++;
        playLists.emplace_back(comb);
        return;
    }

    int lowLim = (pos == 0) ? 0 : comb[pos - 1];
    for (int i = lowLim; i < S; i++) {
        comb[pos] = i;
        bruteForce(pos + 1);
        if (numFound == N) {
            break;
        }
    }
}

vector<vector<int>> makePlaylists(int n, int k, int s, double p) {
    requiredRounds = (int)ceil(NUM_ROUNDS * p);

    N = n;
    K = k;
    S = s;
    comb.resize(k);
    bruteForce(0);

    if ((int)playLists.size() < n) {
        int sz = playLists.size();
        int pos = 0;
        while ((int)playLists.size() < n) {
            playLists.emplace_back(playLists[pos]);
            pos = (pos + 1) % sz;
        }
    }

    return playLists;
}

mt19937 gen(45);

int rand(int l, int r) {
    return (l + gen() % (r - l + 1));
}

int guessPlaylist() {
    if (requiredRounds == 0) {
        return 0;
    }

    requiredRounds--;

    vector<map<int, int>> cntPlayLists(N);
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < K; j++) {
            cntPlayLists[i][playLists[i][j]]++;
        }
    }

    set<int> candidates;
    for (int i = 0; i < N; i++) {
        candidates.emplace(i);
    }

    for (int i = 0; i < K && (int)candidates.size() > 1; i++) {
        int songID = nextSong();
        vector<int> toRemove;

        for (int p : candidates) {
            if (cntPlayLists[p][songID] > 0) {
                cntPlayLists[p][songID]--;
            } else {
                toRemove.emplace_back(p);
            }
        }

        for (int p : toRemove) {
            candidates.erase(p);
        }
    }

    int pos = rand(0, candidates.size() - 1);
    return *next(candidates.begin(), pos);
}
